%
% Metodos de Euler e de Heun para a resolucao do problema de valor
% inicial:  y' = f(t,y) com y(t_0) = y_0.
%
% Funcoes chamadas: f_pvi.
%
% L. N. Vicente, Dezembro de 2004.
%
%
t0 = 1;
y0 = 1/27;
%
T  = 10;
nh = 100;
h  = T/nh;
%
u(1)   = y0;
t      = t0;
%
sol(1)      = y0;
t_grelha(1) = t0;
%
for k=1:nh,
    F1 = h*f_pvi(t,u(k));
    t  = t + h;
%
    sol(k+1)      = t^3/27;
    t_grelha(k+1) = t;
%
    F2 = h*f_pvi(t,u(k)+F1);
    u(k+1) = u(k) + 0.5 * ( F1 + F2 );
end
%
uu(1) = y0;
t     = t0;
%
for k=1:nh,
    uu(k+1) = uu(k) + h * f_pvi(t,uu(k));
    t       = t + h;
end
%
plot(t_grelha,u,'--');
hold on;
plot(t_grelha,uu,':');
plot(t_grelha,sol,'-');
hold off
%
% Fim.